Index: branches/2015/dev_r5072_UKMO2_OBS_simplification/NEMOGCM/EXTERNAL/AGRIF/LIB/toamr.c
===================================================================
--- branches/2015/dev_r5072_UKMO2_OBS_simplification/NEMOGCM/EXTERNAL/AGRIF/LIB/toamr.c	(revision 5659)
+++ branches/2015/dev_r5072_UKMO2_OBS_simplification/NEMOGCM/EXTERNAL/AGRIF/LIB/toamr.c	(revision 5682)
@@ -37,288 +37,224 @@
 #include <string.h>
 #include "decl.h"
-char lvargridname[LONG_4C];
-char lvargridname2[LONG_4C];
-
-
-/******************************************************************************/
-/*                       variablenameroottabvars                              */
+
+const char * tabvarsname(const variable *var)
+{
+    static char * tname[5] = {
+        "tabvars",      // v_catvar == 0
+        "tabvars_c",    // v_catvar == 1
+        "tabvars_r",    // v_catvar == 2
+        "tabvars_l",    // v_catvar == 3
+        "tabvars_i"     // v_catvar == 4
+    };
+    return tname[var->v_catvar];    // v_catvar should never be ouside the range [0:4].
+}
+
+/******************************************************************************/
+/*                        variablecurgridtabvars                              */
 /******************************************************************************/
 /* This subroutine is used to create the string                               */
 /******************************************************************************/
 /*                                                                            */
-/*  ----------->  Agrif_Mygrid % tabvars (i) % var                            */
-/*                                                                            */
-/******************************************************************************/
-char *variablenameroottabvars (variable * var)
-{
-  char *ligne;
-
-  ligne = (char *) malloc (LONG_C * sizeof (char));
-  sprintf (ligne, "Agrif_Mygrid %% tabvars(%d) %% var ", var->v_indicetabvars);
-  return ligne;
-}
-
-
-/******************************************************************************/
-/*                        variablenametabvars                                 */
+/*  ----------->  Agrif_Curgrid % tabvars (i)                                 */
+/*                                                                            */
+/******************************************************************************/
+const char * variablecurgridtabvars(int which_grid)
+{
+    static char * varname[4] = {
+        " Agrif_%s(%d)",                // which_grid == 0
+        " Agrif_%s(%d) %% parent_var",  // which_grid == 1
+        " Agrif_Mygrid %% %s(%d)",      // which_grid == 2
+        " Agrif_Curgrid %% %s(%d)",     // which_grid == 3
+    };
+
+    return varname[which_grid];
+}
+
+void WARNING_CharSize(const variable *var)
+{
+    if ( var->v_nbdim == 0 )
+    {
+        if ( convert2int(var->v_dimchar) > 2400 )
+        {
+            printf("WARNING : The dimension of the character  %s   \n", var->v_nomvar);
+            printf("   is upper than 2400. You must change         \n");
+            printf("   the dimension of carray0                    \n");
+            printf("   in the file AGRIF/AGRIF_FILES/modtypes.F90  \n");
+            printf("   line 161. Replace 2400 with %d.              \n", convert2int(var->v_dimchar)+100);
+        }
+        Save_Length_int(convert2int(var->v_dimchar),1);
+    }
+    else if ( var->v_nbdim == 1 )
+    {
+        if ( convert2int(var->v_dimchar) > 200 )
+        {
+            printf("WARNING : The dimension of the character  %s   \n", var->v_nomvar);
+            printf("   is upper than 200. You must change          \n");
+            printf("   the dimension of carray1                    \n");
+            printf("   in the file AGRIF/AGRIF_FILES/modtypes.F90  \n");
+            printf("   line 162. Replace 200 with %d.              \n", convert2int(var->v_dimchar)+100);
+        }
+        Save_Length_int(convert2int(var->v_dimchar),2);
+    }
+    else if ( var->v_nbdim == 2 )
+    {
+        if ( convert2int(var->v_dimchar) > 200 )
+        {
+            printf("WARNING : The dimension of the character  %s   \n", var->v_nomvar);
+            printf("   is upper than 200. You must change          \n");
+            printf("   the dimension of carray2                    \n");
+            printf("   in the file AGRIF/AGRIF_FILES/modtypes.F90  \n");
+            printf("   line 163. Replace 200 with %d.              \n", convert2int(var->v_dimchar)+100);
+        }
+        Save_Length_int(convert2int(var->v_dimchar),3);
+    }
+    else if ( var->v_nbdim == 3 )
+    {
+        if ( convert2int(var->v_dimchar) > 200 )
+        {
+            printf("WARNING : The dimension of the character  %s   \n", var->v_nomvar);
+            printf("   is upper than 200. You must change          \n");
+            printf("   the dimension of carray3                    \n");
+            printf("   in the file AGRIF/AGRIF_FILES/modtypes.F90  \n");
+            printf("   line 164. Replace 200 with %d.              \n", convert2int(var->v_dimchar)+100);
+        }
+        Save_Length_int(convert2int(var->v_dimchar),4);
+    }
+}
+/******************************************************************************/
+/*                           vargridnametabvars                               */
 /******************************************************************************/
 /* This subroutine is used to create the string                               */
 /******************************************************************************/
 /*                                                                            */
-/*  if iorindice = 0 ---------->  Agrif_Gr % tabvars (i) % var                */
-/*                                                                            */
-/*  if iorindice = 1 ---------->  Agrif_Gr % tabvars (12) % var               */
-/*                                                                            */
-/******************************************************************************/
-char *variablenametabvars (variable * var, int iorindice)
-{
-  char *ligne;
-
-  ligne = (char *) malloc (LONG_C * sizeof (char));
-  if ( iorindice == 0 ) sprintf (ligne, " Agrif_Gr %% tabvars(%d)%% var",
-                                 var->v_indicetabvars);
-  else sprintf (ligne, " Agrif_Gr %% tabvars(i)%% var");
-  return ligne;
-}
-
-/******************************************************************************/
-/*                        variablecurgridtabvars                              */
+/*  if iorindice == 0 ----------->  Agrif_Gr % tabvars (i) % array1           */
+/*                                                                            */
+/*  if iorindice == 1 ----------->  Agrif_Gr % tabvars (12) % array1          */
+/*                                                                            */
+/******************************************************************************/
+const char *vargridnametabvars (const variable * var, int iorindice)
+{
+    static char tname_1[LONG_C];
+    static char tname_2[LONG_C];
+
+    if ( iorindice == 0 ) sprintf(tname_1, "Agrif_Gr %% %s(%d)", tabvarsname(var), var->v_indicetabvars);
+    else                  sprintf(tname_1, "Agrif_Gr %% %s(i)",  tabvarsname(var));
+
+    if (!strcasecmp(var->v_typevar, "REAL"))
+    {
+        if      ( !strcasecmp(var->v_nameinttypename,"8") ) sprintf(tname_2, "%% darray%d", var->v_nbdim);
+        else if ( !strcasecmp(var->v_nameinttypename,"4") ) sprintf(tname_2, "%% sarray%d", var->v_nbdim);
+        else                                                sprintf(tname_2, "%% array%d",  var->v_nbdim);
+    }
+    else if (!strcasecmp(var->v_typevar, "integer"))
+    {
+        sprintf(tname_2, "%% iarray%d", var->v_nbdim);
+    }
+    else if (!strcasecmp(var->v_typevar, "logical"))
+    {
+        sprintf(tname_2, "%% larray%d", var->v_nbdim);
+    }
+    else if (!strcasecmp(var->v_typevar, "character"))
+    {
+        WARNING_CharSize(var);
+        sprintf (tname_2, "%% carray%d", var->v_nbdim);
+    }
+
+    strcat(tname_1, tname_2);
+    Save_Length(tname_1, 46);
+
+    return tname_1;
+}
+
+/******************************************************************************/
+/*                           vargridcurgridtabvars                            */
 /******************************************************************************/
 /* This subroutine is used to create the string                               */
 /******************************************************************************/
 /*                                                                            */
-/*  ----------->  Agrif_Curgrid % tabvars (i) % var                           */
-/*                                                                            */
-/******************************************************************************/
-char *variablecurgridtabvars (variable * var,int ParentOrCurgrid)
-{
-  char *ligne;
-
-  ligne = (char *) malloc (LONG_C * sizeof (char));
-  if ( ParentOrCurgrid == 0 ) sprintf (ligne, " Agrif_tabvars(%d) %% var",
-                              var->v_indicetabvars);
-  else if ( ParentOrCurgrid == 1 ) sprintf (ligne,
-                              " Agrif_tabvars(%d) %% parent_var %% var",
-                               var->v_indicetabvars);
-  else if ( ParentOrCurgrid == 2 ) sprintf (ligne,
-                              " Agrif_Mygrid %% tabvars(%d) %% var",
-                               var->v_indicetabvars);
-  else if ( ParentOrCurgrid == 3 ) sprintf (ligne,
-                              " Agrif_Curgrid %% tabvars(%d) %% var",
-                               var->v_indicetabvars);
-  else sprintf (ligne, " AGRIF_Mygrid %% tabvars(%d) %% var",
-                               var->v_indicetabvars);
-  return ligne;
-}
-
-void WARNING_CharSize(variable *var)
-{
-   if ( var->v_nbdim == 0 )
-   {
-      if ( convert2int(var->v_dimchar) > 2050 )
-      {
-         printf("WARNING : The dimension of the character  %s   \n",
-                                                              var->v_nomvar);
-         printf("   is upper than 2050. You must change         \n");
-         printf("   the dimension of carray0                    \n");
-         printf("   in the file AGRIF/AGRIF_FILES/modtypes.F    \n");
-         printf("   line 247. Replace 300 with %d.              \n",
-                                            convert2int(var->v_dimchar)+100);
-      }
-      Save_Length_int(convert2int(var->v_dimchar),1);
-   }
-   else if ( var->v_nbdim == 1 )
-   {
-      if ( convert2int(var->v_dimchar) > 300 )
-      {
-         printf("WARNING : The dimension of the character  %s   \n",
-                                                              var->v_nomvar);
-         printf("   is upper than 300. You must change          \n");
-         printf("   the dimension of carray1                    \n");
-         printf("   in the file AGRIF/AGRIF_FILES/modtypes.F    \n");
-         printf("   line 247. Replace 300 with %d.              \n",
-                                            convert2int(var->v_dimchar)+100);
-      }
-      Save_Length_int(convert2int(var->v_dimchar),2);
-   }
-   else if ( var->v_nbdim == 2 )
-   {
-      if ( convert2int(var->v_dimchar) > 300 )
-      {
-         printf("WARNING : The dimension of the character  %s   \n",
-                                                              var->v_nomvar);
-         printf("   is upper than 300. You must change          \n");
-         printf("   the dimension of carray2                    \n");
-         printf("   in the file AGRIF/AGRIF_FILES/modtypes.F    \n");
-         printf("   line 247. Replace 300 with %d.              \n",
-                                            convert2int(var->v_dimchar)+100);
-      }
-      Save_Length_int(convert2int(var->v_dimchar),3);
-   }
-   else if ( var->v_nbdim == 3 )
-   {
-      if ( convert2int(var->v_dimchar) > 300 )
-      {
-         printf("WARNING : The dimension of the character  %s   \n",
-                                                              var->v_nomvar);
-         printf("   is upper than 300. You must change          \n");
-         printf("   the dimension of carray3                    \n");
-         printf("   in the file AGRIF/AGRIF_FILES/modtypes.F    \n");
-         printf("   line 247. Replace 300 with %d.              \n",
-                                            convert2int(var->v_dimchar)+100);
-      }
-      Save_Length_int(convert2int(var->v_dimchar),4);
-   }
-}
-/******************************************************************************/
-/*                           vargridnametabvars                               */
+/* if which_grid == 0 -->  Agrif_Curgrid % tabvars (i) % array1               */
+/*                                                                            */
+/* if which_grid == 1 -->  Agrif_tabvars (i) % parent_var % array1            */
+/*                                                                            */
+/* if which_grid == 2 -->  Agrif_Gr % tabvars (i) % array1                    */
+/*                                                                            */
+/******************************************************************************/
+const char *vargridcurgridtabvars(const variable *var, int which_grid)
+{
+    static char tname_1[LONG_C];
+    static char tname_2[LONG_C];
+
+    if (!strcasecmp(var->v_typevar,"type"))
+    {
+        sprintf(tname_1, "Agrif_%s_var(Agrif_Curgrid%%fixedrank)%%%s", var->v_modulename, var->v_nomvar);
+    }
+    else
+    {
+        sprintf(tname_1, variablecurgridtabvars(which_grid), tabvarsname(var), var->v_indicetabvars);
+
+        if (!strcasecmp(var->v_typevar, "REAL"))
+        {
+            if      ( !strcasecmp(var->v_nameinttypename,"8") ) sprintf(tname_2, "%% darray%d", var->v_nbdim);
+            else if ( !strcasecmp(var->v_nameinttypename,"4") ) sprintf(tname_2, "%% sarray%d", var->v_nbdim);
+            else                                                sprintf(tname_2, "%% array%d", var->v_nbdim);
+        }
+        else if (!strcasecmp(var->v_typevar, "INTEGER"))
+        {
+            sprintf(tname_2, "%% iarray%d", var->v_nbdim);
+        }
+        else if (!strcasecmp(var->v_typevar, "LOGICAL"))
+        {
+            sprintf(tname_2, "%% larray%d", var->v_nbdim);
+        }
+        else if (!strcasecmp(var->v_typevar, "CHARACTER"))
+        {
+            WARNING_CharSize(var);
+            sprintf(tname_2, "%% carray%d", var->v_nbdim);
+        }
+        strcat(tname_1, tname_2);
+    }
+    Save_Length(tname_1, 46);
+
+    return tname_1;
+}
+
+/******************************************************************************/
+/*                  vargridcurgridtabvarswithoutAgrif_Gr                      */
 /******************************************************************************/
 /* This subroutine is used to create the string                               */
 /******************************************************************************/
 /*                                                                            */
-/*  if iorindice == 0 ----------->  Agrif_Gr % tabvars (i) % var % array1     */
-/*                                                                            */
-/*  if iorindice == 1 ----------->  Agrif_Gr % tabvars (12) % var % array1    */
-/*                                                                            */
-/******************************************************************************/
-char *vargridnametabvars (variable * var,int iorindice)
-{
-  char *tmp;
-  char tmp1[LONG_C];
-
-  tmp = variablenametabvars (var,iorindice);
-  strcpy(tmp1,tmp);
-  if ( todebugfree == 1 ) free(tmp);
-
-  sprintf (lvargridname, "%s", tmp1);
-  if (!strcasecmp (var->v_typevar, "REAL"))
-    {
-      if ( !strcasecmp(var->v_nameinttypename,"8") )
-                           sprintf (lvargridname2, "%% darray%d", var->v_nbdim);
-      else if ( !strcasecmp(var->v_nameinttypename,"4") )
-                           sprintf (lvargridname2, "%% sarray%d", var->v_nbdim);
-      else sprintf (lvargridname2, "%% array%d", var->v_nbdim);
-    }
-  else if (!strcasecmp (var->v_typevar, "INTEGER"))
-    {
-      sprintf (lvargridname2, "%% iarray%d", var->v_nbdim);
-    }
-  else if (!strcasecmp (var->v_typevar, "LOGICAL"))
-    {
-      sprintf (lvargridname2, "%% larray%d", var->v_nbdim);
-    }
-  else if (!strcasecmp (var->v_typevar, "CHARACTER"))
-    {
-      WARNING_CharSize(var);
-      sprintf (lvargridname2, "%% carray%d", var->v_nbdim);
-    }
-
-  strcat (lvargridname, lvargridname2);
-
-  Save_Length(lvargridname,42);
-  Save_Length(lvargridname2,42);
-  return lvargridname;
-}
-
-/******************************************************************************/
-/*                           vargridcurgridtabvars                            */
-/******************************************************************************/
-/* This subroutine is used to create the string                               */
-/******************************************************************************/
-/*                                                                            */
-/* if ParentOrCurgrid == 0 -->  Agrif_Curgrid % tabvars (i) % var % array1    */
-/*                                                                            */
-/* if ParentOrCurgrid == 1 -->  Agrif_tabvars (i) % parent_var %var % array1  */
-/*                                                                            */
-/* if ParentOrCurgrid == 2 -->  Agrif_Gr % tabvars (i) % var % array1         */
-/*                                                                            */
-/******************************************************************************/
-char *vargridcurgridtabvars (variable * var,int ParentOrCurgrid)
-{
-  char *tmp;
-  char tmp1[LONG_C];
-
- if (!strcasecmp(var->v_typevar,"type"))
-  {
-  strcpy(lvargridname2,"");
-  sprintf(lvargridname,"Agrif_%s_var(Agrif_Curgrid%%fixedrank)%%%s",var->v_modulename,var->v_nomvar);
-  printf("modulename = %s %s\n",var->v_nomvar, var->v_modulename);
-  }
-  else
-  {
-  tmp = variablecurgridtabvars (var,ParentOrCurgrid);
-  strcpy(tmp1,tmp);
-  if ( todebugfree == 1 ) free(tmp);
-
-  sprintf (lvargridname, "%s", tmp1);
-  if (!strcasecmp (var->v_typevar, "REAL"))
-    {
-      if ( !strcasecmp(var->v_nameinttypename,"8") )
-                           sprintf (lvargridname2, "%% darray%d", var->v_nbdim);
-      else if ( !strcasecmp(var->v_nameinttypename,"4") )
-                           sprintf (lvargridname2, "%% sarray%d", var->v_nbdim);
-      else sprintf (lvargridname2, "%% array%d", var->v_nbdim);
-    }
-  else if (!strcasecmp (var->v_typevar, "INTEGER"))
-    {
-      sprintf (lvargridname2, "%% iarray%d", var->v_nbdim);
-    }
-  else if (!strcasecmp (var->v_typevar, "LOGICAL"))
-    {
-      sprintf (lvargridname2, "%% larray%d", var->v_nbdim);
-    }
-  else if (!strcasecmp (var->v_typevar, "CHARACTER"))
-    {
-      WARNING_CharSize(var);
-      sprintf (lvargridname2, "%% carray%d", var->v_nbdim);
-    }
-  }
-
-  strcat (lvargridname, lvargridname2);
-
-  Save_Length(lvargridname,42);
-  Save_Length(lvargridname2,42);
-  return lvargridname;
-}
-
-/******************************************************************************/
-/*                  vargridcurgridtabvarswithoutAgrif_Gr                      */
-/******************************************************************************/
-/* This subroutine is used to create the string                               */
-/******************************************************************************/
-/*                                                                            */
-/******************************************************************************/
-char *vargridcurgridtabvarswithoutAgrif_Gr (variable * var)
-{
-
-  sprintf (lvargridname, "(%d) %% var", var->v_indicetabvars);
-
-  if (!strcasecmp (var->v_typevar, "REAL"))
-    {
-      if ( !strcasecmp(var->v_nameinttypename,"8") )
-                           sprintf (lvargridname2, "%% darray%d", var->v_nbdim);
-      else if ( !strcasecmp(var->v_nameinttypename,"4") )
-                           sprintf (lvargridname2, "%% sarray%d", var->v_nbdim);
-      else sprintf (lvargridname2, "%% array%d", var->v_nbdim);
-    }
-  else if (!strcasecmp (var->v_typevar, "INTEGER"))
-    {
-      sprintf (lvargridname2, "%% iarray%d", var->v_nbdim);
-    }
-  else if (!strcasecmp (var->v_typevar, "LOGICAL"))
-    {
-      sprintf (lvargridname2, "%% larray%d", var->v_nbdim);
-    }
-  else if (!strcasecmp (var->v_typevar, "CHARACTER"))
-    {
-      WARNING_CharSize(var);
-      sprintf (lvargridname2, "%% carray%d", var->v_nbdim);
-    }
-
-  strcat (lvargridname, lvargridname2);
-
-  Save_Length(lvargridname,42);
-  Save_Length(lvargridname2,42);
-  return lvargridname;
+/******************************************************************************/
+const char *vargridcurgridtabvarswithoutAgrif_Gr(const variable *var)
+{
+    static char tname_1[LONG_C];
+    static char tname_2[LONG_C];
+
+    sprintf(tname_1, "(%d)", var->v_indicetabvars);
+
+    if (!strcasecmp (var->v_typevar, "REAL"))
+    {
+        if      ( !strcasecmp(var->v_nameinttypename,"8") ) sprintf(tname_2, "%% darray%d", var->v_nbdim);
+        else if ( !strcasecmp(var->v_nameinttypename,"4") ) sprintf(tname_2, "%% sarray%d", var->v_nbdim);
+        else                                                sprintf(tname_2, "%% array%d", var->v_nbdim);
+    }
+    else if (!strcasecmp(var->v_typevar, "INTEGER"))
+    {
+        sprintf(tname_2, "%% iarray%d", var->v_nbdim);
+    }
+    else if (!strcasecmp(var->v_typevar, "LOGICAL"))
+    {
+        sprintf(tname_2, "%% larray%d", var->v_nbdim);
+    }
+    else if (!strcasecmp(var->v_typevar, "CHARACTER"))
+    {
+        WARNING_CharSize(var);
+        sprintf(tname_2, "%% carray%d", var->v_nbdim);
+    }
+
+    strcat(tname_1, tname_2);
+    Save_Length(tname_1, 46);
+
+    return tname_1;
 }
 
@@ -333,51 +269,32 @@
 /*                                                                            */
 /******************************************************************************/
-char *vargridparam (variable * v, int whichone)
-{
-  typedim dim;
-  listdim *newdim;
-  char newname[LONG_4C];
-
-  newdim = v->v_dimension;
-  if (!newdim) return "";
-
-  strcpy (tmpvargridname, "(");
-  while (newdim)
-  {
-     dim = newdim->dim;
-
-     strcpy(newname,"");
-     strcpy(newname,
-            ChangeTheInitalvaluebyTabvarsName(dim.first,List_Global_Var,
-                                                                     whichone));
-                                                                     
-        strcpy(newname,ChangeTheInitalvaluebyTabvarsName(newname,
-                       List_Common_Var,whichone));
-
-        strcpy(newname,ChangeTheInitalvaluebyTabvarsName(newname,
-                       List_ModuleUsed_Var,whichone));
-
-     strcat (tmpvargridname, newname);
-     strcat (tmpvargridname, " : ");
-
-     strcpy(newname,"");
-     strcpy(newname,ChangeTheInitalvaluebyTabvarsName
-                        (dim.last,List_Global_Var,whichone));
-                        
-        strcpy(newname,ChangeTheInitalvaluebyTabvarsName
-                       (newname, List_Common_Var,whichone));   
-                       
-        strcpy(newname,ChangeTheInitalvaluebyTabvarsName
-                       (newname, List_ModuleUsed_Var,whichone));                                            
-                        
-     Save_Length(tmpvargridname,46);
-     strcat (tmpvargridname, newname);
-     newdim = newdim->suiv;
-     if (newdim) strcat (tmpvargridname, ",");
-  }
-  strcat (tmpvargridname, ")");
-  strcat (tmpvargridname, "\0");
-  Save_Length(tmpvargridname,40);
-  return tmpvargridname;
+const char * vargridparam(const variable *var)
+{
+    typedim dim;
+    listdim *newdim;
+    char newname[LONG_M];
+
+    newdim = var->v_dimension;
+    if (!newdim) return "";
+
+    strcpy (tmpvargridname, "(");
+    while (newdim)
+    {
+        dim = newdim->dim;
+        strcpy(newname,ChangeTheInitalvaluebyTabvarsName(dim.first,List_Global_Var));
+        strcpy(newname,ChangeTheInitalvaluebyTabvarsName(newname,List_Common_Var));
+        strcpy(newname,ChangeTheInitalvaluebyTabvarsName(newname,List_ModuleUsed_Var));
+        strcat(tmpvargridname, newname);
+        strcat(tmpvargridname, " : ");
+        strcpy(newname,ChangeTheInitalvaluebyTabvarsName(dim.last,List_Global_Var));
+        strcpy(newname,ChangeTheInitalvaluebyTabvarsName(newname, List_Common_Var));
+        strcpy(newname,ChangeTheInitalvaluebyTabvarsName(newname, List_ModuleUsed_Var));
+        strcat(tmpvargridname, newname);
+        newdim = newdim->suiv;
+        if (newdim) strcat(tmpvargridname, ",");
+    }
+    strcat(tmpvargridname, ")\0");
+    Save_Length(tmpvargridname,40);
+    return tmpvargridname;
 }
 
@@ -396,7 +313,7 @@
 {
   FILE *probdim;
-  char ligne[LONG_C];
-
-  probdim = associate("probdim_agrif.h");
+  char ligne[LONG_M];
+
+  probdim = open_for_write("probdim_agrif.h");
   sprintf (ligne, "Agrif_Probdim = %d", dimprob);
   tofich (probdim, ligne,1);
@@ -421,11 +338,7 @@
   FILE *keys;
 
-  keys = associate ("keys_agrif.h");
-  fprintf(keys,"      AGRIF_USE_FIXED_GRIDS = 0\n");
-  fprintf(keys,"      AGRIF_USE_ONLY_FIXED_GRIDS = 0\n");
-  if (fixedgrids     == 1) fprintf(keys,"      AGRIF_USE_FIXED_GRIDS = 1\n");
-  if (onlyfixedgrids == 1)
-                         fprintf(keys,"      AGRIF_USE_ONLY_FIXED_GRIDS = 1\n");
-
+  keys = open_for_write("keys_agrif.h");
+  fprintf(keys,"      AGRIF_USE_FIXED_GRIDS = %d\n", fixedgrids);
+  fprintf(keys,"      AGRIF_USE_ONLY_FIXED_GRIDS = %d\n", onlyfixedgrids);
   fclose(keys);
 }
@@ -444,11 +357,15 @@
 void write_modtypeagrif_file()
 {
-  char ligne[LONG_C];
+  char ligne[LONG_M];
   FILE *typedata;
-
-  typedata = associate ("modtype_agrif.h");
+  int i;
+
+  typedata = open_for_write("modtype_agrif.h");
   /* AGRIF_NbVariables : number of variables                                  */
-  sprintf (ligne, "AGRIF_NbVariables = %d",indicemaxtabvars);
-  tofich(typedata,ligne,1);
+  for (i=0;i<NB_CAT_VARIABLES;i++)
+   {
+    sprintf (ligne, "Agrif_NbVariables(%d) = %d",i,indicemaxtabvars[i]);
+    tofich(typedata,ligne,1);
+   }
   fclose (typedata);
 }
@@ -460,21 +377,14 @@
 /******************************************************************************/
 /*                                                                            */
-/*    Agrif_Gr % tabvars (i) % var % namevar = "variable"                     */
-/*                                                                            */
-/******************************************************************************/
-void write_createvarnameagrif_file(variable *v,FILE *createvarname,
-                                                       int *InitEmpty)
-{
-  char ligne[LONG_C];
-  char *tmp;
-  char temp1[LONG_C];
-
-  tmp =  variablenametabvars(v,0);
-  strcpy (temp1, tmp);
-  if ( todebugfree == 1 ) free(tmp);
-
-  *InitEmpty = 0 ;
-  sprintf(ligne, "%s %% namevar = \"%s\"",temp1,v->v_nomvar);
-  tofich(createvarname,ligne,1);
+/*    Agrif_Gr % tabvars (i) % namevar = "variable"                           */
+/*                                                                            */
+/******************************************************************************/
+void write_createvarnameagrif_file(variable *v,FILE *createvarname, int *InitEmpty)
+{
+    char ligne[LONG_M];
+
+    *InitEmpty = 0 ;
+    sprintf(ligne, "Agrif_Gr %% %s(%d) %% namevar = \"%s\"",tabvarsname(v),v->v_indicetabvars,v->v_nomvar);
+    tofich(createvarname,ligne,1);
 }
 
@@ -488,62 +398,33 @@
 /*                                                                            */
 /******************************************************************************/
-void write_Setnumberofcells_file(char *name)
-{
-  char ligne[LONG_C];
-  FILE *setnumberofcells;
-
-  if ( IndicenbmaillesX != 0 )
-  {
-  setnumberofcells=associate(name);
-
-  if (onlyfixedgrids != 1 )
-  {
-  sprintf (ligne,
-           "Agrif_Gr %% nb(1) = Agrif_Gr %% tabvars(%d) %% var %% iarray0",
-           IndicenbmaillesX);
-  }
-  else
-  {
-  sprintf (ligne,
-           "Agrif_Gr %% nb(1) = Agrif_Curgrid %% tabvars(%d) %% var %% iarray0",
-           IndicenbmaillesX);
-  }
-  tofich (setnumberofcells, ligne,1);
-  if (dimprob > 1)
-  {
-     if (onlyfixedgrids != 1 )
-     {
-     sprintf (ligne,
-           "Agrif_Gr %% nb(2) = Agrif_Gr %% tabvars(%d) %% var %% iarray0",
-           IndicenbmaillesY);
-     }
-     else
-     {
-     sprintf (ligne,
-           "Agrif_Gr %% nb(2) = Agrif_Curgrid %% tabvars(%d) %% var %% iarray0",
-           IndicenbmaillesY);
-     }
-
-     tofich (setnumberofcells, ligne,1);
-  }
-  if (dimprob > 2)
-  {
-     if (onlyfixedgrids != 1 )
-     {
-     sprintf (ligne,
-           "Agrif_Gr %% nb(3) = Agrif_Gr %% tabvars(%d) %% var %% iarray0",
-           IndicenbmaillesZ);
-     }
-     else
-     {
-     sprintf (ligne,
-           "Agrif_Gr %% nb(3) = Agrif_Curgrid %% tabvars(%d) %% var %% iarray0",
-           IndicenbmaillesZ);
-     }
-     tofich (setnumberofcells, ligne,1);
-  }
-
-  fclose (setnumberofcells);
-  }
+void write_Setnumberofcells_file()
+{
+    char ligne[LONG_VNAME];
+    char cformat[LONG_VNAME];
+    FILE *setnumberofcells;
+
+    if ( IndicenbmaillesX == 0 )  return;
+
+    setnumberofcells = open_for_write("SetNumberofcells.h");
+
+    if ( onlyfixedgrids == 1 )
+        strcpy(cformat, "Agrif_Gr %% nb(%d) = Agrif_Curgrid %% tabvars_i(%d) %% iarray0");
+    else
+        strcpy(cformat, "Agrif_Gr %% nb(%d) = Agrif_Gr %% tabvars_i(%d) %% iarray0");
+
+    sprintf(ligne, cformat, 1, IndicenbmaillesX);
+    tofich(setnumberofcells, ligne, 1);
+
+    if ( dimprob > 1 )
+    {
+        sprintf(ligne, cformat, 2, IndicenbmaillesY);
+        tofich(setnumberofcells, ligne, 1);
+    }
+    if ( dimprob > 2 )
+    {
+        sprintf(ligne, cformat, 3, IndicenbmaillesZ);
+        tofich(setnumberofcells, ligne, 1);
+    }
+    fclose(setnumberofcells);
 }
 
